<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    public function up(): void
    {
        Schema::create('sc_office_users', function (Blueprint $blueprint) {
            $blueprint->id();
            $blueprint->unsignedBigInteger('fk_office')->nullable();
            $blueprint->unsignedBigInteger('fk_user');
            $blueprint->unsignedBigInteger('fk_role');
            $blueprint->unsignedBigInteger('fk_usercreator')->nullable();
            $blueprint->timestamp('created_at')->useCurrent();
            $blueprint->unsignedBigInteger('fk_userupdater')->nullable();
            $blueprint->timestamp('updated_at')->useCurrentOnUpdate()->nullable();
            $blueprint->boolean('is_active')->default(true);

            $blueprint->foreign('fk_office')->references('id')->on('sy_offices');
            $blueprint->foreign('fk_user')->references('id')->on('sc_users');
            $blueprint->foreign('fk_role')->references('id')->on('sc_roles');
            $blueprint->foreign('fk_usercreator')->references('id')->on('sc_users');
            $blueprint->foreign('fk_userupdater')->references('id')->on('sc_users');
        });

        DB::table('sc_office_users')->insert([
            ['fk_office' => null, 'fk_user' => 1, 'fk_role' => 1, 'fk_usercreator' => 1],
        ]);
    }

    public function down(): void
    {
        Schema::dropIfExists('sc_office_users');
    }
};
